## metview 5.16.0

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

include( ${INCLUDE_CONFIG}-local-config.cmake OPTIONAL )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
#set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )


project( MetviewMiniBundle VERSION 5.16.0 LANGUAGES C CXX )
set(CPACK_PACKAGE_NAME Metview)  # so that the source tarball will have the name 'Metview'


# list all the packages we incorporate into the bundle
set(MV_BUNDLE_PACKAGES METVIEW MARS_CLIENT MIR ATLAS ECKIT)

if(METVIEW_SITE STREQUAL ecmwf )
    list(APPEND MV_BUNDLE_PACKAGES FDB)
endif()

# create a variabe for each package we bundle
foreach (bunpack ${MV_BUNDLE_PACKAGES})
    set(MV_BUNDLE_CONTAINS_${bunpack} 1)
endforeach()


# -------------------------------------------------------------------------------------
# settings which are required across the packages to get a working Metview installation

#general
set(ENABLE_ODB           OFF CACHE BOOL "ODB support")
set(ENABLE_EXPERIMENTAL  OFF CACHE BOOL "Experimental features")
set(ENABLE_FORTRAN       NOT_SET CACHE BOOL "Fortran features")

#mars
set(ECMWF             OFF CACHE BOOL "build the client as for ECMWF")
set(CONFIG_FDB        OFF CACHE BOOL "database configuration to access FDB")
set(ENABLE_UDP_STATS  OFF CACHE BOOL "")
set(ENABLE_MPI        OFF CACHE BOOL "")
set(ENABLE_BUILD_TOOLS  OFF   CACHE BOOL   "")


# if the user did bot supply a value for ENABLE_FORTRAN, then unset it
# (we want to then use the default behaviour, per package)
if(ENABLE_FORTRAN STREQUAL "NOT_SET")
    unset(ENABLE_FORTRAN)
    unset(ENABLE_FORTRAN CACHE)
endif()


# -------------------------------------------------------------------------------------

macro(my_bundle_pkg)
    ecbuild_bundle( ${ARGV} )
endmacro()

include( ecbuild_bundle )

ecbuild_bundle_initialize()

    ecbuild_add_option( FEATURE EXPOSE_SUBPACKAGES
                        DEFAULT OFF
                        DESCRIPTION "Allow separate use of the sub-packages in the bundle")



    # if the installer does not want to expose the sub-packages then we need to:
    # a) change $PREFIX so that everything is installed into a sub-directory
    # b) change the location of the Metview startup script so it's installed
    #    where intended (Metview takes care of this)

    if (NOT ENABLE_EXPOSE_SUBPACKAGES)
        set(ORIGINAL_CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
        set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/lib/metview-bundle")
    endif()


    if(MV_BUNDLE_CONTAINS_FDB)
        set( FDB_CONF_FILE /usr/local/apps/fdb/etc/Config )
        list(APPEND MV_BUNDLE_PACKAGES FDB)
        ecbuild_bundle( PROJECT fdb                GIT "ssh://git@git.ecmwf.int/mars/fdb_vintage"    TAG  4.11.0   )
    else()
        set(FDB_DIR "/dummy/path/for/bundle")
    endif()

    my_bundle_pkg( PROJECT eckit        GIT "ssh://git@git.ecmwf.int/ecsdk/eckit"       TAG  1.20.0                )
    my_bundle_pkg( PROJECT atlas        GIT "ssh://git@git.ecmwf.int/atlas/atlas"       TAG  0.29.0                )
    my_bundle_pkg( PROJECT mir          GIT "ssh://git@git.ecmwf.int/mir/mir"           TAG  1.12.3                  )
    my_bundle_pkg( PROJECT mars-client  GIT "ssh://git@git.ecmwf.int/mars/mars-client"  TAG  6.33.10  )
    my_bundle_pkg( PROJECT metview      GIT "ssh://git@git.ecmwf.int/metv/metview"      TAG  5.16.0              )

    ecbuild_dont_pack(FILES configure.sh;ecmwf;make-tarball.sh;test-tarball.sh;configure.clang.sh;bamboo)

ecbuild_bundle_finalize()


ecbuild_info("ENABLE_EXPOSE_SUBPACKAGES is ${ENABLE_EXPOSE_SUBPACKAGES}:")
if (ENABLE_EXPOSE_SUBPACKAGES)
    ecbuild_info("All packages in the bundle will be installed at the same level into:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
else()
    ecbuild_info("All packages in the bundle will be installed into a sub-directory:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
    ecbuild_info ("The Metview startup script will be installed into:")
    ecbuild_info("  ${ORIGINAL_CMAKE_INSTALL_PREFIX}/bin")
endif()

=== metview/CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
#
#  Metview-specific:
#  -DMETVIEW_SITE=ecmwf | other
#  -DMETVIEW_SCRIPT=name-of-generated-startup-script
#  -DMARS_HOME=/path/to/MARS/home  (requires WITH_MARS=ON)
#  -DMAGICS_PATH=/path/to/magics   (requires WITH_PLOTTING=ON)
#  -DEXTRA_TITLE=extra-title-string
#  -DLOG_DIR=/path/to/dir/for/module/log/files
#  -DODB1_USE_SCRIPT_PATH=/path/to/odb1/use/script

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

 
if(POLICY CMP0025)
  cmake_policy(SET CMP0025 NEW)
endif()


# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
else()
    set(MV_BIN_DIR bin/metview_bin)
endif()

# set INSTALL_BIN_DIR before calling project()
# so that the installation rpaths are set correctly
set(ORIGINAL_INSTALL_BIN_DIR ${INSTALL_BIN_DIR}) # will restore at the end
set(INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

project(metview VERSION 5.16.0 LANGUAGES C CXX)


set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)



include( ecbuild_system NO_POLICY_SCOPE )

IF(APPLE)
  SET(MACOSX_RPATH 1)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  #SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
ENDIF(APPLE)

ecbuild_requires_macro_version( 1.9 )

#ecbuild_add_cxx11_flags()  # Magics 3 requires C++11/14
set (CMAKE_CXX_STANDARD 17)
set (CMAKE_C_STANDARD 99)

###############################################################################
# some options of this project

option( ENABLE_UI             "enable the user interface"                          ON )
option( ENABLE_PLOTTING       "enable the plotting module"                         ON )
option( ENABLE_MARS           "enable MARS access"                                 OFF )
option( ENABLE_ODB            "enable ODB"                                         OFF )
option( ENABLE_USAGE_LOG      "enable usage logging (only at ECMWF)"               OFF )
option( ENABLE_QT_DEBUG       "enable Qt debugging messages"                       OFF )
option( ENABLE_INPE           "enable INPE modules"                                OFF )
option( ENABLE_URL_DOWNLOAD   "enable downloading of files from URLs"              ON )
option( ENABLE_WEATHER_ROOM   "enable Weather Room plot export (only at ECMWF)"    OFF )
option( ENABLE_SHARE_PLOT     "enable sharing of plots (only at ECMWF)"            OFF )
option( ENABLE_SHARE_TO_GLOBE "enable Globe plot export (only at ECMWF)"           OFF )
option( ENABLE_NETWORK_PROXY  "enable network proxy settings for WMS"              OFF )
option( ENABLE_EXPERIMENTAL   "enable experimental modules"                        OFF )
option( ENABLE_CONTRIB        "enable externally contributed modules"              OFF )
option( ENABLE_METVIEW_FORTRAN "enable modules which use Fortran code"             OFF )
option( ENABLE_METVIEW_DOCS   "enable building of documentation"                   OFF )
option( ENABLE_CODES_UI       "enable building of CodesUI"                         OFF )
option( ENABLE_STVL           "enable STVL access module"                          OFF )
option( ENABLE_STATIONS_DB    "enable database of WMO stations"                    ON )
#option( ENABLE_CODE_WEBHELP   "enable inline web help in code editor"              OFF )




###############################################################################


if( ENABLE_METVIEW_FORTRAN )
    ecbuild_enable_fortran( REQUIRED )
    set(HAVE_METVIEW_FORTRAN 1)
endif()


# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()



# if we don't explicitly state that we're at ECMWF, then assume we're not, and use the generic config
if(NOT METVIEW_SITE STREQUAL ecmwf)
    set( SITE_WMO_CODE "255")    # DO WE NEED AN OPTION TO ALLOW INSTALLERS TO SPECIFY THIS?
    set( MV_ENVIRON    "common")
    set( AT_ECMWF "FALSE" )
    ecbuild_info("Building outside ECMWF")
else()
    set( SITE_WMO_CODE "098")
    set( MV_ENVIRON    "ecm_lnx64")
    set( AT_ECMWF "TRUE" )
    add_definitions( -DECMWF )
    ecbuild_info("Building inside ECMWF")
endif()



# default startup script name
if(NOT DEFINED METVIEW_SCRIPT )
    set( METVIEW_SCRIPT "metview" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${METVIEW_SCRIPT})

# ensure we don't build shared libraries
set(BUILD_SHARED_LIBS OFF)


# STVL
if (ENABLE_STVL)
    if(DEFINED MV_STVL_EXE)
        if(NOT EXISTS ${MV_STVL_EXE})
            ecbuild_critical("MV_STVL_EXE: (${MV_STVL_EXE}) defined but does not exist")
        endif()
    else()
        ecbuild_critical("MV_STVL_EXE must be defined if ENABLE_STVL is on")
    endif()
endif()

# Weather Room plot export (ECMWF only)
if(ENABLE_WEATHER_ROOM)
    if(AT_ECMWF)
        find_package( Boost 1.49.0 )            # Weather Room export needs Boost
        set(MV_WEATHER_ROOM_BUILT true)
    else()
        ecbuild_error("ENABLE_WEATHER_ROOM only available when building at ECMWF")
    endif()
else()
    set(MV_WEATHER_ROOM_BUILT false)
endif()

# Globe plot export (ECMWF only)
if(ENABLE_SHARE_TO_GLOBE)
    if(NOT AT_ECMWF)
        ecbuild_error("ENABLE_SHARE_TO_GLOBE only available when building at ECMWF")
    endif()
    if(NOT ENABLE_SHARE_PLOT)
        ecbuild_error("ENABLE_SHARE_TO_GLOBE only available when ENABLE_SHARE_PLOT is enabled")
    endif()
endif()


# Meteogram (ECMWF only, default is ON unless otherwise stated)
if(AT_ECMWF)
    if(NOT DEFINED ENABLE_METEOGRAM)
        set(ENABLE_METEOGRAM "ON")
    endif()
else()
    set(ENABLE_METEOGRAM "OFF")
endif()


if(ENABLE_INPE)
    set(METVIEW_INPE true)
endif()





# ----------------
# look for eccodes 
# ----------------

ecbuild_find_package(NAME eccodes VERSION 2.24.0 REQUIRED)

set( GRIB_API_INCLUDE_DIRS  ${eccodes_INCLUDE_DIRS} )
set( GRIB_API_LIBRARIES     ${eccodes_LIBRARIES} )
set( GRIB_API_DEFINITIONS   ${eccodes_DEFINITIONS} )
set( GRIB_API_TPL_LIBRARIES ${eccodes_TPL_LIBRARIES} )
set( grib_api_BASE_DIR      ${eccodes_BASE_DIR} )
add_definitions(-DGRIB_HANDLING_PACKAGE=ecCodes)



# --------------------
# look for MARS client 
# --------------------

ecbuild_find_package(NAME mars_client VERSION 6.28.6 REQUIRED)
ecbuild_find_package(NAME mir VERSION 1.6.1 REQUIRED)


# for the mars-client itself, RPC is not necessary, but Metview needs it,
# so abort if mars-client could not find it

if (NOT mars_client_HAVE_RPC)
    message( FATAL_ERROR "Could not find RPC libraries. Consider installing rpcgen and libtirpc-devel" )
endif()


set(MARSCLIENT_LIBS "marsclient")


# check which post-processing libraries it found
list(FIND mars_client_FEATURES "PPROC_MIR"  HAVE_PPROC_MIR)
list(FIND mars_client_FEATURES "PPROC_EMOS" HAVE_PPROC_EMOS)
if (HAVE_PPROC_MIR EQUAL -1)
    set(HAVE_PPROC_MIR 0)
else()
    set(HAVE_PPROC_MIR 1)
    list(APPEND MARSCLIENT_LIBS "mir")
endif()
if (HAVE_PPROC_EMOS EQUAL -1)
    set(HAVE_PPROC_EMOS 0)
else()
    set(HAVE_PPROC_EMOS 1)
    ecbuild_find_package(NAME libemos REQUIRED)
    list(APPEND MARSCLIENT_LIBS "emos")
endif()


if( NOT HAVE_PPROC_MIR AND NOT HAVE_PPROC_EMOS  )
    message( FATAL_ERROR "MARS client requires PPROC (for which MIR or EMOSLIB is required)" )
endif()


if(HAVE_PPROC_MIR)
    ecbuild_find_package(NAME eckit VERSION 1.0 REQUIRED)  # for DivRot, which uses eckit directly
endif()

# decide which interpolation library to use by default
if(HAVE_PPROC_MIR)
    set(DEFAULT_INTERP_PACKAGE "MIR")
else()
    set(DEFAULT_INTERP_PACKAGE "EMOS")
endif()




# look for curl because it is needed for the Mars Web API client
find_package(CURL)
if(CURL_FOUND)
    list(APPEND MARSCLIENT_LIBS ${CURL_LIBRARIES})
endif()



# local MARS access
if(ENABLE_MARS)
    set( MARS_ACCESS MARS_local )
    set( METVIEW_MARS 1 )
    if(DEFINED MARS_LOCAL_HOME)
        ecbuild_info("MARS_LOCAL_HOME=${MARS_LOCAL_HOME}")
        if(NOT EXISTS ${MARS_LOCAL_HOME})
            ecbuild_critical("MARS_LOCAL_HOME (${MARS_LOCAL_HOME}) does not exist")
        else()
            set(MARS_HOME ${MARS_LOCAL_HOME})
        endif()
    else()
        ecbuild_critical("If setting local MARS access, -DMARS_LOCAL_HOME=/path/to/mars/home must be provided.")
    endif()

    list(FIND mars_client_FEATURES "ODB" HAVE_MARS_ODB)
    if (HAVE_MARS_ODB EQUAL -1)
        set(ENABLE_MARS_ODB "OFF")
    else()
        set(ENABLE_MARS_ODB "ON")
    endif()
    

    if(ENABLE_MARS_ODB)
        set(ENABLE_ODB 1)
        set(METVIEW_MARS_ODB 1)
    endif()

    #find_library( FDB  REQUIRED )
    #ecbuild_debug("FDB: ${FDB_LIBRARIES}" )

else()
    if(${CURL_FOUND})
        set( MARS_ACCESS MARS_webapi )
    else()
        set( MARS_ACCESS MARS_none )
        add_definitions(-DNOCURL)
        ecbuild_warn("Could not find the Curl library - disabling Web API Mars")
    endif()
endif()


# Network access (download via URLs)
if(ENABLE_URL_DOWNLOAD)
    if(NOT CURL_FOUND)
        ecbuild_critical("URL_DOWNLOAD was enabled, but the 'curl' development package was not found.")
    endif()
endif()



###############################################################################
# local project requirements

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )




#message(FATAL_ERROR "ECCODES_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS}")


if(ENABLE_ODB)
    ecbuild_find_package(NAME odc    VERSION 1.1.0 REQUIRED)
    if( odc_FOUND )
        set(METVIEW_ODB_API_LIBRARIES odccore)
        set(METVIEW_ODB 1)

        add_definitions(-DMETVIEW_ODB_NEW -DMETVIEW_ODB)
    else()
        if(ENABLE_MARS_ODB)
            ecbuild_critical("ENABLE_ODB was set, but ODB not found")
            set(ENABLE_MARS_ODB 0)
            set(METVIEW_MARS_ODB 0)
        endif()
    endif()

    # ODB-1

    #ecbuild_use_package( PROJECT ODB )
    ecbuild_find_package(NAME odb)

    if(odb_FOUND)
        if(EXISTS ${ODB_PATH}/bin)
            if(EXISTS ${ODB_PATH}/bin/odbsql)
                add_definitions(-DMETVIEW_ODB_OLD)
                set(ENABLE_ODB1 "ON")

                if(ODB1_USE_SCRIPT) # was an ODB-1 use script name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_USE_SCRIPT=${ODB1_USE_SCRIPT}")
                endif()

                if(ODB1_MODULE) # was an ODB-1 module name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_MODULE=${ODB1_MODULE}")
                endif()

                if(ODB1_VERSION) # was an ODB-1 module name passed?
                    set(MV_ODB1_VERSION ${ODB1_VERSION})
                else()
                    set(MV_ODB1_VERSION "ANY")
                endif()

            else()
                ecbuild_warn("ODB-1 support is DISABLED - No odbsql script found in ${ODB_PATH}/bin")
            endif()
        else()
            ecbuild_warn("ODB-1 found, but no bin directory in ${ODB_PATH}")
        endif()
    else()
        ecbuild_warn("ODB-1 not found!")
    endif()
endif()


if(ENABLE_PLOTTING)
    #ecbuild_use_package( PROJECT magics VERSION 4.1.0)
    ecbuild_find_package(NAME magics VERSION 4.10.0 REQUIRED)

    if( magics_FOUND )

        set(MAGICS_LIB_DIR "${magics_BASE_DIR}/lib")

        if(ENABLE_UI AND (NOT magics_HAVE_METVIEW))
            ecbuild_critical("Magics must be built with Metview and Qt support!")
        endif()

=== mir/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.


cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

find_package(ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project(mir VERSION 1.12.3 LANGUAGES CXX)

set(PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "") # needed for generating .b files for persistent support
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


ecbuild_add_option(FEATURE BUILD_TOOLS        DEFAULT OFF DESCRIPTION "build the command line tools (install)")
ecbuild_add_option(FEATURE MIR_DOWNLOAD_MASKS DEFAULT ON  DESCRIPTION "download LSM files")
ecbuild_add_option(FEATURE TEST_ASSERTIONS    DEFAULT ON  DESCRIPTION "test: regressions")
ecbuild_add_option(FEATURE NETCDF             DEFAULT ON  DESCRIPTION "support for netCDF" REQUIRED_PACKAGES "NetCDF COMPONENTS C")
ecbuild_add_option(FEATURE PNG                DEFAULT OFF DESCRIPTION "support for PNG encoding" REQUIRED_PACKAGES PNG)
ecbuild_add_option(FEATURE OMP                DEFAULT OFF DESCRIPTION "support for OpenMP shared memory parallelism" REQUIRED_PACKAGES "OpenMP COMPONENTS CXX")

if(NOT TARGET OpenMP::OpenMP_CXX)
    set(mir_HAVE_OMP 0)
endif()

ecbuild_find_package(NAME eccodes VERSION 2.24 REQUIRED)
ecbuild_find_package(NAME eckit   VERSION 1.19 REQUIRED)

ecbuild_add_option(FEATURE ATLAS DEFAULT ON DESCRIPTION "support for Atlas" REQUIRED_PACKAGES "atlas VERSION 0.25")


set(MIR_LIBRARIES mir)

if(HAVE_BUILD_TOOLS)
    set(mir_INSTALL_TOOLS)
else()
    set(mir_INSTALL_TOOLS NOINSTALL)
endif()

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

add_subdirectory(src)
add_subdirectory(etc)
add_subdirectory(share)
add_subdirectory(tests)


ecbuild_add_resources(TARGET ${PROJECT_NAME}_top_files SOURCES AUTHORS README NOTICE LICENSE INSTALL COPYING)
ecbuild_install_project(NAME ${PROJECT_NAME})

ecbuild_print_summary()

=== metview/src/Macro/CMakeLists.txt ===
# TODO: mvimportDesktop  perlaccess????


set(Macrolib_srcs
    value.cc code.cc variable.cc context.cc script.cc files.cc
    misc.cc number.cc stack.cc date.cc mstring.cc request.cc
    Unix.cc grib.cc mlist.cc module.cc remote.cc function.cc
    matrix.cc image.cc arith.cc extern.cc mvector.cc mtable.cc library.cc
    debug.cc bufr.cc compute.cc mgptset.cc vismod.cc macroy.c
    netcdf.cc object.cc pngjpeg.cc mflextra.cc python.cc GribVertical.cc
    methods.cc
)


include_directories( include )  # relative to the current source directory


if( HAVE_PPROC_MIR )
    add_definitions( -DHAVE_PPROC_MIR )
    include_directories(${MIR_INCLUDE_DIRS})
endif()

if( HAVE_PPROC_EMOS )
    add_definitions( -DHAVE_PPROC_EMOS )
endif()

if( ENABLE_UI )
    add_definitions( -DENABLE_UI )
endif()

if( ENABLE_PLOTTING )
    add_definitions( -DENABLE_PLOTTING )
endif()


ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/macrol.c
	COMMAND ${FLEX_EXECUTABLE} -l ${CMAKE_CURRENT_SOURCE_DIR}/macrol.l\; sed -e s/yy/zz/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/macrol.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macrol.l)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/macroy.c
	COMMAND ${BISON_EXECUTABLE} -y ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y\; sed -e s/yy/zz/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/macroy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y ${CMAKE_CURRENT_BINARY_DIR}/macrol.c)

ADD_CUSTOM_TARGET(macrolex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/macroy.c ${CMAKE_CURRENT_BINARY_DIR}/macrol.c)



#set(Macro_libs ${STANDARD_METVIEW_LIBS_ODB} ${METVIEW_EXTRA_LIBRARIES})

if(ENABLE_ODB)
    list(APPEND Macrolib_srcs codb.cc)
    list(APPEND Macro_libs ${METVIEW_ODB_API_LIBRARIES})
endif()


ecbuild_append_to_rpath("../lib") # so that libMvMacro can find libMvUtil, etc
ecbuild_add_library( TARGET           MvMacro
					 TYPE             SHARED
					 SOURCES          ${Macrolib_srcs}
					 TEMPLATES        ${common_templates}
					 DEFINITIONS      ${METVIEW_EXTRA_DEFINITIONS}
					 PRIVATE_INCLUDES ${METVIEW_STANDARD_INCLUDES}
					 PUBLIC_LIBS      ${STANDARD_METVIEW_LIBS} ${Macro_libs} ${METVIEW_EXTRA_LIBRARIES}
					)

set(link_libs MvMacro)
if (HAVE_METVIEW_FORTRAN)
    list(APPEND link_libs macro_api_f90)
endif()

#target_link_libraries(link_libs)


#target_link_libraries(MvMacro
#	 ${Macro_libs} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
#	"-Wl,--whole-archive"
##    app models
##    "-Wl,--no-whole-archive"
#)
# GIVES THE FOLLOWING ERROR:
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS): In function `_ZGVbN2v___log_finite':
#/home/abuild/rpmbuild/BUILD/glibc-2.22/mathvec/../sysdeps/x86_64/fpu/svml_finite_alias.S:31: multiple definition of `_ZGVbN2v___log_finite'
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS):/home/abuild/rpmbuild/BUILD/glibc-2.22/mathvec/../sysdeps/x86_64/fpu/svml_finite_alias.S:31: first defined here
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS): In function `_ZGVcN4v___log_finite':


ecbuild_add_executable( TARGET       macro
                        SOURCES      main.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${link_libs} #MvMacro
                    )

#ecbuild_add_executable( TARGET       pytest
#						SOURCES      python.cc
#						DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
#						LIBS         ${link_libs} MvMacro
#					)


ADD_DEPENDENCIES(macro macrolex)


######################################################################################

# PROBLEM getting CMake to accept the arguments to 'sed'. One possibility would be to
# put this into a separate script; another would be to simply put the beau.h file
# directly into the repository and skip the step of generating it.

#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beaul.c
#	COMMAND lex -l ${CMAKE_CURRENT_SOURCE_DIR}/beaul.l\; sed -e s/yy/zz/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/beaul.c
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/beaul.l)
#
#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beauy.c
#	COMMAND yacc -t ${CMAKE_CURRENT_SOURCE_DIR}/beauy.y\; sed -e s/yy/zz/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/beauy.c
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y)
#
#set(BS \\)
##	COMMAND sed -e 's/\\(.*\\)/\\"\\1\\",/' < ${CMAKE_CURRENT_SOURCE_DIR}/beau.ps > ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#	COMMAND sed -e 's/${BS}(.*${BS})/${BS}\"${BS}1\",/' < ${CMAKE_CURRENT_SOURCE_DIR}/beau.ps > ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/beauy.y)
#
#
#ADD_CUSTOM_TARGET(beaulex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/beauy.c ${CMAKE_CURRENT_BINARY_DIR}/beaul.c ${CMAKE_CURRENT_BINARY_DIR}/beau.h)
#
#
#ecbuild_add_executable( TARGET       beautify
#                        SOURCES      beauy.y beautify.c 
#                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
#                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR}
#                        LIBS         ${Macro_libs}
#                    )
#
#ADD_DEPENDENCIES(beautify beaulex)


######################################################################################


set(mvimport_srcs
    mvimport.c
)

ecbuild_add_executable( TARGET       mvimport
                        SOURCES      ${mvimport_srcs}
                        DEFINITIONS
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )


######################################################################################


set(mvimportDesktop_srcs
    mvimportDesktop.c
)

ecbuild_add_executable( TARGET       mvimportDesktop
                        SOURCES      ${mvimportDesktop_srcs}
                        DEFINITIONS
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

=== metview/src/codes_ui/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_CURRENT_SOURCE_DIR}/../../../ecbuild)

project( codes_ui LANGUAGES C CXX VERSION 1.7.1 )

set(BUILD_WITHIN_METVIEW ${ENABLE_CODES_UI})

remove_definitions(-DMETVIEW)

if (BUILD_WITHIN_METVIEW)
    set(CODES_UI_INSTALL_BIN_SUBDIR "bin/metview_bin")
    set(CODES_UI_BUILD_WITHIN_METVIEW "true")
else()
    set(CODES_UI_INSTALL_BIN_SUBDIR "bin")
    set(CODES_UI_BUILD_WITHIN_METVIEW "false")
endif()


# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
#if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
#    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
#else()
#    set(MV_BIN_DIR bin/metview_bin)
#endif()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake"  "${CMAKE_CURRENT_SOURCE_DIR}/../../../ecbuild/cmake")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)

#set(METVIEW_INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.9 )
set (CMAKE_CXX_STANDARD 17)

###############################################################################
# some options of this project

option( ENABLE_QT_DEBUG      "enable Qt debugging messages"                       OFF )

###############################################################################

#C check if it is an exeternal build (outside the metview source)
set(__external_build  1)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../AppMod")
   set(__external_build 0)
endif()

# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()


# default startup script name
if(NOT DEFINED CODES_UI_SCRIPT )
    set( CODES_UI_SCRIPT "codes_ui" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${CODES_UI_SCRIPT})

# ensure we don't build shared libraries
if (NOT BUILD_WITHIN_METVIEW)
    set(BUILD_SHARED_LIBS OFF)
endif()

message("CMAKE_BINARY_DIR = ${CMAKE_BINARY_DIR}")
message("CMAKE_CURRENT_SOURCE_DIR = ${CMAKE_CURRENT_SOURCE_DIR}")


###############################################################################
# local project requirements

#ecbuild_add_option( FEATURE ECCODES DESCRIPTION "" DEFAULT OFF )

if (NOT BUILD_WITHIN_METVIEW)
    ecbuild_find_package(NAME eccodes VERSION 2.19.0 REQUIRED)
    set( GRIB_API_INCLUDE_DIRS ${eccodes_INCLUDE_DIRS} )
    set( GRIB_API_LIBRARIES    ${eccodes_LIBRARIES} )
    set( GRIB_API_DEFINITIONS  ${eccodes_DEFINITIONS} )
    set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
    add_definitions(-DGRIB_HANDLING_PACKAGE=ecCodes)
else()
    set(GRIB_API_PATH )
endif()

ecbuild_declare_project()

###############################################################################
# Find external dependencies

if (NOT BUILD_WITHIN_METVIEW)

    find_package(Qt6Widgets)
    if( Qt6Widgets_FOUND )
        find_package(Qt6Core5Compat      REQUIRED)
        find_package(Qt6Widgets      REQUIRED)
        find_package(Qt6Gui          REQUIRED)
        find_package(Qt6Xml          REQUIRED)
        find_package(Qt6Network      REQUIRED)
        find_package(Qt6Svg          REQUIRED)
        find_package(Qt6SvgWidgets   REQUIRED)
        ecbuild_debug("Qt6 version ${Qt6Widgets_VERSION_STRING} was found")
        include_directories(${Qt6Core5Compat_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Xml_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Svg_INCLUDE_DIRS} ${Qt6SvgWidgets_INCLUDE_DIRS})
        set( METVIEW_QT 1)
        set( METVIEW_QT6 true)
        add_definitions( -DMETVIEW_QT6 )
    else()
        find_package(Qt5Widgets)
        if( Qt5Widgets_FOUND )
            find_package(Qt5Gui REQUIRED)
            find_package(Qt5Network      REQUIRED)
            find_package(Qt5Xml          REQUIRED)
            find_package(Qt5XmlPatterns  REQUIRED)
            find_package(Qt5Svg          REQUIRED)
            ecbuild_debug("Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
            include_directories(${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5XmlPatterns_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Svg_INCLUDE_DIRS})
            set( METVIEW_QT 1)
            set( METVIEW_QT5 true)
            add_definitions( -DMETVIEW_QT5 )
        else()
            ecbuild_critical("Neither Qt5 nor Qt6 were found ...")
        endif()
    endif()

    if( NOT ENABLE_QT_DEBUG )
        add_definitions( -DQT_NO_DEBUG_OUTPUT )
    endif()
endif()

###############################################################################
# contents
######set( METVIEW_TPLS grib_api odb_api EXPAT NetCDF PangoCairo Proj4 libemos)

#When we build outside the ecmwf dev environment (i.e. from the tarball) we have
#a different directory structure.
if(__external_build)
    set(SRC_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src)
    set(SHARE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/share/codes_ui/etc)
    set(STARTUP_SCRIPT_TEMPLATE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts/codes_ui_base.in")
    set(WINDOWS_STARTUP_SCRIPT_PATH "${CMAKE_CURRENT_SOURCE_DIR}/codes_ui.bat")
    set(KEYPROFILE_PATH ${SHARE_PATH})
    set(VERSION_PATH ${SHARE_PATH})
    set(IMAGE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/share/codes_ui/etc/images)
    set(EXE_SRC_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src/codes_ui)
    set(LIBCODESUI_SRC_PATH "${SRC_PATH}/libCodesUi")
else()
    set(SRC_PATH "..")
    set(SHARE_PATH "../../share/metview/app-defaults")
    set(STARTUP_SCRIPT_TEMPLATE_PATH "codes_ui_base.in")
    set(WINDOWS_STARTUP_SCRIPT_PATH "codes_ui.bat")
    set(KEYPROFILE_PATH ".")
    set(VERSION_PATH ".")
    set(IMAGE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../share/metview/app-defaults/images)
    set(EXE_SRC_PATH ".")
    set(LIBCODESUI_SRC_PATH ".")
endif()

message(STATUS "CODES_UI __external_build=${__external_build}")
message(STATUS "CODES_UI BUILD_WITHIN_METVIEW=${BUILD_WITHIN_METVIEW}")


set( METVIEW_STANDARD_INCLUDE_DIRS        
        ${SRC_PATH}/libFTimeUtil
        ${SRC_PATH}/libMetview
        ${LIBCODESUI_SRC_PATH}
        ${SRC_PATH}/BufrExaminer
        ${SRC_PATH}/GribExaminer
        .
       )
set(STANDARD_METVIEW_LIBS MetviewCUI FTimeUtilCUI CodesUi)


set(METVIEW_EXTRA_LIBRARIES eccodes)

set (METVIEW_QT_INCLUDE_DIRS "")
set (METVIEW_QT_LIBRARIES "")
if( METVIEW_QT5)
    list( APPEND METVIEW_QT_INCLUDE_DIRS ${Qt5Widgets_INCLUDE_DIR} ${Qt5Gui_INCLUDE_DIR} ${Qt5Xml_INCLUDE_DIR} ${Qt5XmlPatterns_INCLUDE_DIR} ${Qt5Network_INCLUDE_DIR} ${Qt5Svg_INCLUDE_DIR} ${SRC_PATH}/libMvQtUtil ${SRC_PATH}/libMvQtGui )
    list( APPEND METVIEW_QT_LIBRARIES  MvQtGuiCUI MvQtUtilCUI ${Qt5Widgets_LIBRARIES} ${Qt5Gui_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5XmlPatterns_LIBRARIES} ${Qt5Network_LIBRARIES}  ${Qt5Svg_LIBRARIES})
elseif( METVIEW_QT6)
    list( APPEND METVIEW_QT_INCLUDE_DIRS ${Qt6Widgets_INCLUDE_DIR} ${Qt6Gui_INCLUDE_DIR} ${Qt6Xml_INCLUDE_DIR} ${Qt6Network_INCLUDE_DIR} ${Qt6Svg_INCLUDE_DIR} ${SRC_PATH}/libMvQtUtil ${SRC_PATH}/libMvQtGui )
    list( APPEND METVIEW_QT_LIBRARIES  MvQtGuiCUI MvQtUtilCUI ${Qt6Core5Compat_LIBRARIES} ${Qt6Widgets_LIBRARIES} ${Qt6Gui_LIBRARIES} ${Qt6Xml_LIBRARIES}  ${Qt6Network_LIBRARIES}  ${Qt6Svg_LIBRARIES})
endif()

message(STATUS "CODES_UI METVIEW_EXTRA_LIBRARIES    => ${METVIEW_EXTRA_LIBRARIES}")
message(STATUS "CODES_UI STANDARD_METVIEW_LIBS      => ${STANDARD_METVIEW_LIBS}")
message(STATUS "CODES_UI METVIEW_QT_INCLUDE_DIRS    => ${METVIEW_QT_INCLUDE_DIRS}")


# we need to make sure that
#set(CMAKE_INCLUDE_DIRECTORIES_BEFORE "ON")

set(METVIEW_STANDARD_INCLUDES ${METVIEW_STANDARD_INCLUDE_DIRS})
link_directories( ${CMAKE_CURRENT_SOURCE_DIR}/lib )
message(STATUS "CODES_UI METVIEW_STANDARD_INCLUDE_DIRS  => ${METVIEW_STANDARD_INCLUDES}")


add_definitions( -DR64 -DECCODES_UI -DH_INCLUDES_CC -DUSE_NEW_IO )

# ecbuild automatically test endiness and sets variable EC_BIG_ENDIAN or EC_LITTLE_ENDIAN
if( EC_LITTLE_ENDIAN )
    add_definitions(-DLITTLE_END) # needed for libMars/bufr.h
endif()

# -------------------------
# compiler-specific options
# -------------------------

if     (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
    ecbuild_add_cxx_flags("-fpermissive -Wno-write-strings -Wno-deprecated")
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
    ecbuild_add_cxx_flags("-fpermissive -Wno-deprecated -undefined dynamic_lookup")
endif()

if     (CMAKE_C_COMPILER_ID STREQUAL "Clang" )
    ecbuild_add_c_flags("-undefined dynamic_lookup")     #  "-fno-common  -mmacosx-version-min=10.8")
endif()

if( EC_OS_NAME MATCHES "windows" )
    # Suppress compiler warnings
    # Suppress warnings about using 'insecure' functions.
    ecbuild_add_cxx_flags("/D_CRT_SECURE_NO_WARNINGS")
    # Suppress warnings about using well-known C functions.
    ecbuild_add_cxx_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    # Suppress C4267: warns about possible loss of data when converting 'size_t' to 'int'.
    ecbuild_add_cxx_flags("/wd4267")
endif()

set(TAR_ROOT $ENV{TMPDIR}/codes_ui_tar_tmp)
set(NEED_TAR 0)
if(NOT __external_build AND NOT BUILD_WITHIN_METVIEW)
    list( APPEND CPACK_SOURCE_INSTALLED_DIRECTORIES ${TAR_ROOT} .)
    set(NEED_TAR 1)
endif()

macro(add_files_to_tar FILES TAR_DIR)

    if(NEED_TAR)

        message(STATUS "add_files_to_tar()")
        message(STATUS "TAR_DIR=${TAR_DIR}")

        set(tmpdir $ENV{TMPDIR}/codes_ui_tar_tmp/${TAR_DIR})
        message(STATUS "tmpdir=${tmpdir}")

        file(MAKE_DIRECTORY ${tmpdir})
        foreach( f ${FILES} )
            message(STATUS "  file=${f}")
            file(COPY ${f}
                DESTINATION ${tmpdir}
            )
        endforeach()

    endif()

endmacro(add_files_to_tar)

#---------------------------------------
# libCodesUi
#---------------------------------------

set(libCodesUi_srcs_names
    CodesDirHandler.cc
    CodesDirHandler.h
)

foreach( f ${libCodesUi_srcs_names} )
   list(APPEND libCodesUi_srcs ${LIBCODESUI_SRC_PATH}/${f})
endforeach()

ecbuild_add_library( TARGET      CodesUi
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libCodesUi_srcs}
                     TEMPLATES   ${common_templates}
                     PUBLIC_INCLUDES    ${METVIEW_STANDARD_INCLUDES} ${LOCAL_EXTRA_INCLUDE_DIRS}
                     PUBLIC_LIBS ${METVIEW_EXTRA_LIBRARIES}
)

add_files_to_tar("${libCodesUi_srcs}" "src/libCodesUi")

#---------------------------------------
# libFTimeUtilCUI
#---------------------------------------

set(libFTimeUtilCUI_srcs_names
    fdyntime.cc
    fmettim.cc
    fobject.cc
    fsortabl.cc
    fstatime.cc
    fdyntime.h
    fmettim.h
    fobject.h
    fsortabl.h
    fstatime.h

)

foreach( f ${libFTimeUtilCUI_srcs_names} )
   list(APPEND libFTimeUtilCUI_srcs ${SRC_PATH}/libFTimeUtil/${f})
endforeach()

ecbuild_add_library( TARGET      FTimeUtilCUI
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libFTimeUtilCUI_srcs}
                     TEMPLATES   ${common_templates}
                     PUBLIC_INCLUDES    ${METVIEW_STANDARD_INCLUDES}
                     PUBLIC_LIBS ${METVIEW_EXTRA_LIBRARIES}
)

add_files_to_tar("${libFTimeUtilCUI_srcs}" "src/libFTimeUtil")

#---------------------------------------
# libMetviewCUI
#---------------------------------------

set(libMetviewCUI_srcs_names
    MvAbstractApplication.cc
    MvLocation.cc
    MvLog.cc
    MvObs.cc
    MvObsSet.cc  
    BufrFilterDef.cc
    BufrFilterEngine.cc
    BufrLocationCollector.cc
    BufrMetaData.cc
    GribMetaData.cc
    LogHandler.cc
    MvBufrEdition.cc
    MvBufrElementTable.cc
    MvEccBufr.cc
    MvException.cc
    MvKeyCondition.cc

=== metview/test/macros/CMakeLists.txt ===

# ------------------------------------------------------------------------
# MACRO metview_etc_files
# Ensures the files listed in ETC_FILES are copied to the build directory
# and that they will be installed at install time
# ------------------------------------------------------------------------


set (POST_INSTALL_TEST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh)
set (MVRUN "${INSTALLED_METVIEW_STARTUP_SCRIPT}")


macro(metview_macro_test)
    set(options POST_INSTALL)
    set(single_value_args MACRO)
    set(multi_value_args RESOURCES MACRO_ARGS)
    cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}" ${_FIRST_ARG} ${ARGN} )


    ecbuild_add_test(TARGET      ${_PAR_MACRO}.test
                     COMMAND     ${FULL_STARTUP_SCRIPT_PATH}
                     TYPE        SCRIPT
                     ARGS        -nocreatehome -b ${_PAR_MACRO} ${_PAR_MACRO_ARGS}
                     RESOURCES   ${_PAR_MACRO} ${_PAR_RESOURCES} test_utils.mv )


    # add to the post-install tests too
    if (_PAR_POST_INSTALL)
        string (REPLACE ";" " " MACRO_ARGS "${_PAR_MACRO_ARGS}")  # ';' -> ' '
        file(APPEND ${POST_INSTALL_TEST_SCRIPT} "${MVRUN} -b ${_PAR_MACRO} ${MACRO_ARGS}\n")
    endif()

    set(all_tests "${all_tests}${_PAR_MACRO} ") # note the spacing
endmacro()



# write the start of the post-install test script
file(WRITE  ${POST_INSTALL_TEST_SCRIPT} "#!/bin/sh\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# Run the tests on the installed version of Metview\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# -------------------------------------------------\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "set -eax\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")



set(all_tests) # empty to start with



if(ENABLE_PLOTTING)
    metview_macro_test(MACRO     HelloWorld.mv
                       RESOURCES set_output.mv ../data/z500.grb
                       POST_INSTALL)

    metview_macro_test(MACRO     layoutx3.mv
                       RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO     plot_from_read_grib.mv
                       RESOURCES set_output.mv ../data/fc_data.grib)

    metview_macro_test(MACRO     plot_bufr.mv
                       RESOURCES set_output.mv ../data/temp_10.bufr)
endif()

if(NOT ENABLE_PLOTTING)
    metview_macro_test(MACRO     no_plotting.mv
                       POST_INSTALL)
endif()

metview_macro_test(MACRO     grib_dates.mv
                   RESOURCES  ../data/fc_data.grib
                              ../data/hindcast.grib
                              ../data/fc_long_step.grib
                              ../data/monthly_avg.grib
                              ../data/flexpart_minute_step.grib
                   POST_INSTALL)

metview_macro_test(MACRO     grib_keys.mv
                   RESOURCES  ../data/fc_data.grib
                   POST_INSTALL)


metview_macro_test(MACRO     grib_gradient.mv
                   RESOURCES  ../data/grad_input_global.grib
                              ../data/grad_ref_global.grib
                              ../data/grad_input_global_sn.grib
                              ../data/grad_ref_global_sn.grib
                              ../data/u_sn_reg_ll.grib
                              ../data/grad_ref_u_sn.grib
                              ../data/second_deriv_input_global.grib
                              ../data/second_deriv_ref_global.grib
                              ../data/div_vor_ref.grib
                              ../data/laplace_ref.grib
                              ../data/geostrophic.grib
                    POST_INSTALL)

metview_macro_test(MACRO     grib_gradient_analytic.mv
                   RESOURCES  ../data/grad_input_global.grib)

metview_macro_test(MACRO     grib_integral.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb
                              ../data/LL_2x2_cellarea_ref.grib
                              ../data/t1000_reg_gg_N48.grib
                              ../data/t1000_red_gg_N48.grib
                              ../data/rgg_small_subarea.grib
                              ../data/reg_gg_N48_cellarea_ref.grib
                              ../data/red_gg_N48_cellarea_ref.grib
                              ../data/rgg_O1280_subarea.grib
                              ../data/rgg_small_subarea_cellarea_ref.grib)

metview_macro_test(MACRO     grib_nearest_gridpoint.mv
                   RESOURCES  ../data/t1000_LL_1x1.grb
                              ../data/t1000_LL_1x1_subarea.grb
                              ../data/t1000_LL_2x2.grb
                              ../data/t1000_LL_2x2_with_missing.grb
                              ../data/t1000_reg_gg_N48.grib
                              ../data/t1000_red_gg_N48.grib
                              ../data/ll_no_pole.grib
                              ../data/rgg_small_subarea.grib
                              ../data/regular_gaussian_subarea.grib
                              ../data/rgg_western_subarea.grib
                              ../data/reduced_ll.grib
                              ../data/nearest_gridpoint_gpt_ref_missing_1.gpt
                              ../data/nearest_gridpoint_gpt_ref_missing_2.gpt)

metview_macro_test(MACRO     grib_vertical.mv
                   RESOURCES ../data/t_lnsp_ml137.grb
                             ../data/pres_ml137.grib
                             ../data/thickness_ml137.grib
                             ../data/vertint_ref.grib
                             ../data/tq_ml137.grib
                             ../data/z_ml137_ref.grib
                             ../data/ml2pl_ref.grib
                             ../data/ml_to_hl_asl_ref.grib
                             ../data/ml_to_hl_agr_ref.grib
                             ../data/ml_to_hl_agr_surf_ref.grib
                             ../data/ml_to_hl_agr_log_surf_ref.grib
                             ../data/ml_to_hl_log_asl_ref.grib
                             ../data/ml_to_hl_log_agr_ref.grib
                             ../data/t_80Pa.grib
                             ../data/omega_ml.grib
                             ../data/omega_pl.grib
                             ../data/dt_dp_ref.grib)

metview_macro_test(MACRO     polygon_mask.mv
                  RESOURCES  ../data/poly_ref.grib
                             ../data/poly_multi_ref.grib)

metview_macro_test(MACRO     interpolation_sh_to_ll.mv
                   RESOURCES  ../data/t1000_SH.grb
                   POST_INSTALL)

metview_macro_test(MACRO     interpolation_sh_to_rgg.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_rgg_to_ll.mv
                   RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)

metview_macro_test(MACRO     interp_default.mv
                   RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)

if (HAVE_PPROC_EMOS AND HAVE_PPROC_MIR)
    metview_macro_test(MACRO     interp_emos.mv
                       RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)
endif()

if (HAVE_PPROC_MIR)
    metview_macro_test(MACRO     interp_mir.mv
                       RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)
endif()

metview_macro_test(MACRO     grib_to_gpt.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb
                              ../data/gpt_to_grib_nearest_sum_reference.grb
                              ../data/mercator.grib
                   POST_INSTALL)

metview_macro_test(MACRO     gpt_to_grib_core.mv
                   RESOURCES  ../data/gpt_to_grib_input_1.gpt
                              ../data/gpt_to_grib_reciprocal_reference.grb
                              ../data/gpt_to_grib_exp_mean_reference.grb
                              ../data/gpt_to_grib_exp_sum_reference.grb
                   POST_INSTALL)

metview_macro_test(MACRO     gpt_to_grib_with_template.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb ../data/10U_GG.grb)

metview_macro_test(MACRO     gpt_to_grib_nearest.mv
                   RESOURCES  ../data/t1000_LL_7x7.grb
                              ../data/example_XYLDTZ.geo
                              ../data/example_XYLDTZ_with_missing.geo
                              ../data/gpt_to_grib_nearest_sum_reference.grb
                              ../data/gpt_to_grib_nearest_sum_missing_reference.grb
                              ../data/gpt_to_grib_nearest_mean_reference.grb
                              ../data/gpt_to_grib_nearest_mean_missing_reference.grb
                              ../data/gpt_to_grib_nearest_count_reference.grb
                              ../data/nearest_gridpoint_gpt_ref_1.gpt)

metview_macro_test(MACRO     geopoint_types.mv
                   RESOURCES  ../data/bufr_obs_filter_basic_reference.gpt
                              ../data/example_POLAR_VECTOR.geo
                              ../data/example_XYZ.geo
                              ../data/example_XY_VECTOR.geo)

metview_macro_test(MACRO     gpt_set.mv
                   RESOURCES  ../data/gpt_to_grib_input_1.gpt
                              ../data/bufr_picker_reference.gpt
                              ../data/bufr_obs_filter_area_reference.gpt
                              ../data/bufr_obs_filter_custom_reference.gpt
                              ../data/nearest_gridpoint_gpt_ref_1.gpt
                              ../data/t1000_LL_1x1.grb
                              ../data/hindcast.grib)

#metview_macro_test(MACRO     interpolation_gg_to_subarea.mv
#                   RESOURCES  ../data/10U_GG.grb)

metview_macro_test(MACRO     bufr_obs_filter.mv
                   RESOURCES  ../data/bufr-3.bufr
                              ../data/compress_3.bufr
                              ../data/bufr_obs_filter_basic_reference.gpt
                              ../data/temp_10.bufr
                              ../data/bufr_obs_filter_level_reference.gpt
                              ../data/synop_multi_subset_uncompressed.bufr
                              ../data/bufr_obs_filter_area_reference.gpt
                              ../data/bufr_obs_filter_missvals_1_reference.gpt
                              ../data/bufr_obs_filter_missvals_2_reference.gpt
                              ../data/amsua_13.bufr
                              ../data/bufr_obs_filter_time_reference.gpt
                              ../data/bufr_obs_filter_custom_reference.gpt
                              ../data/bufr_obs_filter_blockstation_reference.gpt
                              ../data/aircraft_10.bufr
                              ../data/trop1.bufr
                              ../data/bufr_obs_filter_descriptor_string_reference.gpt
                              ../data/bufr_obs_filter_subtype_reference.gpt
                              ../data/temp_small.bufr
                              ../data/bufr_obs_filter_ncols_reference.gpt
                              ../data/bufr_obs_filter_ncols_miss_reference.gpt
                              ../data/missing_ident.bufr
                              ../data/stnid_with_internal_spaces.bufr
                              ../data/bufr_obs_filter_ncols_stnids_spaces_reference.gpt
                              ../data/ssd_missing_location.bufr
                              ../data/ssd_missing_location_ref.gpt
                              )

metview_macro_test(MACRO     bufr_picker.mv
                   RESOURCES  ../data/temp_10.bufr ../data/bufr_picker_reference_ws.gpt
                              ../data/cape-ens.bufr ../data/bufr_picker_two_coordinate_descriptors_compressed_reference.gpt
                              ../data/2t-ens.bufr ../data/bufr_picker_two_coordinate_descriptors_uncompressed_reference.gpt
                             ../data/temp_small.bufr ../data/bufr_picker_ncols_reference.gpt
                   POST_INSTALL)

if(ENABLE_UI)

=== debian/changelog ===
metview (5.16.0-2) unstable; urgency=medium

  * FIx FTBFS with g++ 12 (ctime include). Closes: #1016239
  * Standards-Verersion: 4.6.1 no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 30 Jul 2022 10:34:09 +0100

metview (5.16.0-1) unstable; urgency=medium

  * New upstream release
  * Build against libatlas-ecmef-dev >= 0.29.0-2

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 20 May 2022 08:21:30 +0100

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  ecbuild (>= 3.3.0-2),
  gfortran | fortran-compiler, 
  python3-all-dev,
  flex, 
  bison, 
  libtirpc-dev,
  libncurses5-dev,
  libjemalloc-dev,
  libpng-dev,
  libssl-dev,
  libhdf5-dev, 
  liblapack-dev,
  libpango1.0-dev, 
  libmetkit-dev,
  libmetkit-utils,
  odc [!powerpc !armel !armhf !i386 !mipsel],
  libodc-dev [!powerpc !armel !armhf !i386 !mipsel],
  libfftw3-dev,
  libeigen3-dev,
  chrpath, 
  mksh,
  libfckit-dev,
  libqt5webkit5-dev (>= 5.212.0~alpha2-15), 
  qtbase5-dev, libqt5xmlpatterns5-dev,
  libemos-dev, libemos-bin,
  libeccodes-dev (>= 2.22.0),
  libeccodes-tools,
  libatlas-ecmwf-dev (>= 0.29.0-2), 
  libatlas-ecmwf-utils,
  libeckit-dev (>= 1.10.1~),
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev (>= 4.10.0-1~), 
  libmagics++-dev (>= 4.10.0-1~),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkg-config,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libproj-dev, libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  flextra, 
  flexpart,
  libgeotiff-dev
Standards-Version: 4.6.1
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Browser: https://salsa.debian.org:/science-team/metview.git
Vcs-Git: https://salsa.debian.org:/science-team/metview.git

Package: metview
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3
Recommends: magics++, flextra, flexpart
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version}), 
 libxxhash-dev, libsnappy-dev, liblz4-dev, libbz2-dev
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.
